// pages/home/home.js
const db = wx.cloud.database();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    swiperList:[],
    showPopup: false,
    detail:[],
    gridList:
    [
      {name:"课表",icon:"/images/course.png",url:"/pages/course/course"},
      {name:"校历",icon:"/images/schedule.png",url:"/pages/calendar/calendar"},
      {name:"资讯",icon:"/images/notice.png",url:"/pages/information/information"},
    ],
    messageList:[],
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    const db1 = db.collection('swiper');   // 第一个需要查询的数据表集合
    const db2 = db.collection('notice');  // 第二个需要查询的数据表集合
    Promise.all([
      db1.get(),
      db2.where({flag:0}).get()
    ]).then(res => {
      console.log(res[0].data); // 第一个集合的查询结果
      console.log(res[1].data); // 第二个集合的查询结果
      this.setData({
        swiperList: res[0].data ,
        messageList: res[1].data
      })
    }).catch(err => {
      console.error(err);
    });
  },

  showContent(e) {
    console.log(e.currentTarget)
    db.collection('notice')
      .where({_id:e.currentTarget.dataset.mark})
      .get()
      .then(res => {//formData是数据库里面集合的名称
        console.log(res); //如果更新数据成功则输出成功信息
        //var that = this;
        this.setData({
          detail: res.data  //数据赋值
        });
        console.log(res.data);
      }).catch(err => {
        console.log(err); //如果更新数据失败则输出失败信息
    })
    this.setData({
      showPopup: true,
    });
  },

  hideContent() {
    db.collection('notice')
      .where({flag:0})
      .get()
      .then(res => {//formData是数据库里面集合的名称
        console.log(res); //如果更新数据成功则输出成功信息
        //var that = this;
        this.setData({
          messageList: res.data  //数据赋值
        });
        console.log(res.data);
      }).catch(err => {
        console.log(err); //如果更新数据失败则输出失败信息
    })
    this.setData({
      showPopup: false,
    });
  },

  complete(e){
    console.log(e.currentTarget)
    let userCollection = db.collection('notice')
    userCollection.where({
	    //先查询
	    _id: e.currentTarget.dataset.mark
    }).update({
	    data: {
    	    flag:1
      }
    }).then(res => {
	    console.log('更新成功')
    }).catch(err => {
	    console.log('更新失败',err)//失败提示错误信息
    })
      this.hideContent()
  },
  

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {

  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
  
})